<template>
  <div class="rui-widget">
    <div class="rui-widget__header">
      <span class="rui-widget__header__title -flex -gap">
        <strong>{{ resourceNote.username }}</strong>
        <small class="-text--color-mute">
          {{ $d(resourceNote.createdAt, 'compact') }}
          <template v-if="resourceNote.updatedAt.valueOf() !== resourceNote.createdAt.valueOf()">
            &mdash;
            <strong>{{ $t('activerecord.attributes.resource_note.updated_at') }}</strong>
            {{ $d(resourceNote.updatedAt, 'compact') }}
          </template>
        </small>
      </span>

      <div v-if="isOwner" class="-flex-none">
        <rui-toolbar>
          <rui-button icon="pencil" :title="$t('generic.edit')" @click="$emitBus('show-resource-note-form', resourceNote)" />
          <rui-button icon="trash" variant="destructive" :title="$t('generic.destroy')" @click="handleDestroyNote(resourceNote)" />
        </rui-toolbar>
      </div>
    </div>

    <div class="rui-widget__content _writing">{{ resourceNote.content }}</div>
  </div>
</template>

<script>
import RuiButton from '@experiments-labs/rise_ui/src/components/Button/Button.vue'
import RuiToolbar from '@experiments-labs/rise_ui/src/components/Toolbar/Toolbar.vue'

import Toaster from '../../../../tools/Toaster'
import ResourceNote from '../../../../classes/models/ResourceNote'

/**
 * Displays a resource note
 */
export default {
  name: 'GpaResourceNote',
  components: { RuiButton, RuiToolbar },
  props: {
    resourceNote: { required: true, type: [ResourceNote] },
  },
  computed: {
    isOwner () { return this.$store.getters.account?.id === this.resourceNote.userId },
  },
  methods: {
    handleDestroyNote (note) {
      this.$emitBus('ask-confirmation', {
        caption: this.$t('js.resource_note.destroy_warning_title'),
        message: this.$t('js.resource_note.destroy_warning'),
        callback: () => {
          this.$store.dispatch('destroyResourceNote', note.id)
            .then(() => { Toaster.success(this.$t('js.resource_note.successfully_destroyed')) })
            .catch(() => { Toaster.error(this.$t('js.resource_note.failed_to_destroy')) })
        },
      })
    },
  },
}
</script>
